/*
 * Author: Roberto Bruttomesso <roberto.bruttomesso@unisi.ch>
 *
 * Implementation of a simple mutual exclusion protocol
 */


byte turn;

bool C1, C2, T1, T2;

proctype P1( )
{
  do
  :: atomic { (turn == 0)               -> T1 = true; turn = 1; } 
  :: atomic { (turn == 1 &&  T1)        -> C1 = true; T1 = false }
  :: atomic { (turn == 1 &&  C1 && !T2) -> C1 = false; turn = 0 }
  :: atomic { (turn == 1 &&  C1 &&  T2) -> C1 = false; turn = 2 }
  :: atomic { (turn == 2 && !T1)        -> T1 = true; }
  od
}

proctype P2( )
{
  do
  :: atomic { (turn == 0)               -> T2 = true; turn = 2 } 
  :: atomic { (turn == 2 &&  T2)        -> C2 = true; T2 = false }
  :: atomic { (turn == 2 &&  C2 && !T1) -> C2 = false; turn = 0 }
  :: atomic { (turn == 2 &&  C2 &&  T1) -> C2 = false; turn = 1 }
  :: atomic { (turn == 1 && !T2)        -> T2 = true; }
  od
}

init 
{
  C1 = false;
  T1 = false;
  C2 = false;
  T2 = false;

  turn = 0;

  run P1(); run P2()
}  
